/*
 * Created on 16.12.2004
 */
package net.hoopajoo.swingx;

import javax.swing.AbstractAction;
import javax.swing.ImageIcon;

/**
 * Creates an Action that includes ACTION_SELECTED state support
 * This can be used with specially modified buttons, menu entries etc.
 * @author anttix
 */

abstract public class SelectedAction extends AbstractAction {
    public static final String ACTION_SELECTED = "ACTION_SELECTED";
    
    public SelectedAction() {
        super();
        putValue( ACTION_SELECTED, new Boolean( false ) );
    }
    public SelectedAction(String arg0) {
        super(arg0);
        putValue( ACTION_SELECTED, new Boolean( false ) );
    }
    public SelectedAction(String arg0, ImageIcon icon) {
        super(arg0, icon);
        putValue( ACTION_SELECTED, new Boolean( false ) );
    }
    /**
     * Returns selected state of the action.
     * @return  a boolean referring to the selected state
     */
    public boolean isSelected() {
        return ((Boolean)getValue( ACTION_SELECTED )).booleanValue();
    }
    /**
     * Sets selected state of the action
     * @param selected  true if selected, false othervise
     */
    public void setSelected(boolean selected) {
        putValue( ACTION_SELECTED, new Boolean( selected ) );
    }
 }
